//-----------------------------------------------------------------------------
//    Api_2_Tkr_Sevl_3.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_tkr_sevl;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.test.util.* ;

/**
 * Test Area : usim.toolkit...
 *
 * Applet is triggered on Install (Install)
 *
 *
 */

public class Api_2_Tkr_Sevl_3 extends TestToolkitApplet
{

    private short[] EventList = {EVENT_FORMATTED_SMS_PP_ENV, EVENT_FORMATTED_SMS_PP_UPD, EVENT_FORMATTED_SMS_CB};
     
        /**
     * Constructor of the applet
     */
    public Api_2_Tkr_Sevl_3()
    {
        }

    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) {
        

        
        // Create a new applet instance.
        Api_2_Tkr_Sevl_3 thisApplet = new Api_2_Tkr_Sevl_3();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
       
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
                                                           
   }


    public void processToolkit(short event)
    {
        
                
            boolean bRes = false;
            byte    bTestCaseNb = (byte)0x01;
            
            // --------------------------------------------------------------------------
            //  Test Case 6 : Applet3 with no TAR defined registers to 
            //  EVENT_UNFORMATTED_SMS_CB event
            // --------------------------------------------------------------------------

        if (event == EVENT_UNFORMATTED_SMS_CB) {
            
            bRes = true;
            reportTestOutcome(bTestCaseNb, bRes);
            
            // 2- setEvent(EVENT_FORMATTED_SMS_PP_ENV)
            bTestCaseNb = (byte) 0x02;
            try {
                obReg.setEventList(EventList,(short) 0, (short) 1);
                bRes=false;
            }
            catch (ToolkitException e) {    
                bRes = (e.getReason()==ToolkitException.TAR_NOT_DEFINED);
            }
            reportTestOutcome(bTestCaseNb, bRes);

            // 3- setEvent(EVENT_FORMATTED_SMS_PP_UPD)
            bTestCaseNb = (byte) 0x03;
            try {
                obReg.setEventList(EventList,(short) 1, (short) 1);
                bRes=false;
            }       
            catch (ToolkitException e) {    
                bRes = (e.getReason()==ToolkitException.TAR_NOT_DEFINED);
            }
            reportTestOutcome(bTestCaseNb, bRes);

            // 4- setEvent(EVENT_FORMATTED_SMS_CB)
            bTestCaseNb = (byte) 0x04;
            try {
                obReg.setEventList(EventList,(short) 2, (short) 1);
                bRes=false;
            }       
            catch (ToolkitException e) {    
                bRes = (e.getReason()==ToolkitException.TAR_NOT_DEFINED);
            }
            reportTestOutcome(bTestCaseNb, bRes);


            // 5- isEventSet(EVENT_FORMATTED_SMS_PP_ENV)
            //    shall return false
            bTestCaseNb = (byte)0x05;
            bRes = !obReg.isEventSet(EVENT_FORMATTED_SMS_PP_ENV);
            reportTestOutcome(bTestCaseNb, bRes);

            // 6- isEventSet(EVENT_FORMATTED_SMS_PP_UPD)
            //    shall return false
            bTestCaseNb = (byte)0x06;
            bRes = !obReg.isEventSet(EVENT_FORMATTED_SMS_PP_UPD);
            reportTestOutcome(bTestCaseNb, bRes);

            // 7- isEventSet(EVENT_FORMATTED_SMS_CB_ENV)
            //    shall return false
            bTestCaseNb = (byte)0x07;
            bRes = !obReg.isEventSet(EVENT_FORMATTED_SMS_CB);
            reportTestOutcome(bTestCaseNb, bRes);                  

        }              

    }


}