//-----------------------------------------------------------------------------
//    Api_2_Tkr_Sevt_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_tkr_sevt;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.test.util.* ;

/**
 * Test Area : usim.toolkit...
 *
 * Applet is triggered on Install (Install)
 *
 *
 */

public class Api_2_Tkr_Sevt_1 extends TestToolkitApplet
{

    // Events allowed and tested
    private static byte MAX_EVENT = 7; // (2 to 6, 10 and 24)
    private short[] EventList = {(short)EVENT_FORMATTED_SMS_PP_ENV, (short)EVENT_FORMATTED_SMS_PP_UPD, (short)EVENT_UNFORMATTED_SMS_PP_ENV,
                                 (short)EVENT_UNFORMATTED_SMS_PP_UPD, (short)EVENT_UNFORMATTED_SMS_CB, (short)EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,  
                                 (short)EVENT_FORMATTED_SMS_CB}; 
                        
                 

      
    /**
     * Constructor of the applet
     */
    public Api_2_Tkr_Sevt_1() {
    }

    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) {
        

        
        // Create a new applet instance.
        Api_2_Tkr_Sevt_1 thisApplet = new Api_2_Tkr_Sevt_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
       
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
                                                           
   }


    public void processToolkit(short event)
    {
        
                
        boolean bRes = false;
        byte    bTestCaseNb = (byte)0;

        if (event == EVENT_FORMATTED_SMS_PP_ENV){

            // -----------------------------------------------------------------
            // Test Case 1 :For events ranging from 2 to 6, 10 and 24 the
            //              applet calls :
            //              1 - clearEvent() method   No exception shall be thrown
            //              2 - isEventSet() method   Shall return false each time
            //              3 - setEvent() method           No exception shall be thrown
            //              4 - isEventSet() method   Shall return true each time
            //              5 - clearEvent() method   No exception shall be thrown    
            // -----------------------------------------------------------------               
            bTestCaseNb = (byte)1;
            
            try{
                for(short i=0; i < (short)(MAX_EVENT); i++) {
                
                    bRes = false;
                      
                    // 1 - clearEvent() method    No exception shall be thrown      
                    obReg.clearEvent(EventList[i]);                   
                  
                    // 2 - isEventSet() method   Shall return false each time
                    if (obReg.isEventSet(EventList[i])) {            
                        bRes = false;
                        break;
                    }
            
                    // 3 - setEvent() method            No exception shall be thrown
                    obReg.setEvent(EventList[i]);                     
                    
                    // 4 - isEventSet() method   Shall return true each time
                    if (!obReg.isEventSet(EventList[i])) {            
                        bRes = false;
                        break;
                    }
                            
                    // 5 - clearEvent() method   No exception shall be thrown  
                    obReg.clearEvent(EventList[i]);                   
                        
                    bRes = true;        
                }    
                    
            }           
            catch (Exception e) {
                bRes = false;
            } 
                            
            reportTestOutcome ( bTestCaseNb, bRes );
        
                    
            // --------------------------------------------------------------------
            // Test Case 2 : Setting EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM       
            // --------------------------------------------------------------------
                            
            bTestCaseNb = (byte)2;              
            try{
                // No exception shall be thrown  
                obReg.setEvent((short) EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM);
                bRes = true;    
            }
            catch (Exception e) {
                bRes = false;
            }                   
            reportTestOutcome ( bTestCaseNb, bRes );                        
            
            
            
            
            // ------------------------------------------------------------------------------------------------
            // Test Case 3 : Check applet is triggered by an ENVELOPE (EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM)     
            // ------------------------------------------------------------------------------------------------                       
            
            bTestCaseNb = (byte)3;      
            bRes = false;   
            reportTestOutcome ( bTestCaseNb, bRes );        
        }
        if (event == EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM){            
        
            bTestCaseNb = (byte)3;      
            bRes = true;    
            reportTestOutcome ( bTestCaseNb, bRes );    
        }   
        
    }

}