//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gvby;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Gvby extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_gvby";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Gvby() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        response = test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "07" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        addResult(response.checkSw("9000"));

        test.reset();
        test.terminalProfileSession("1719");

        /**********************************************************************/
        /** Testcase 1. Search tag 02    use method getValueByte(0)              */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010033 81C80102 03040506" +
                        "0708090A 0B0C0D0E 0F101112 13141516" +
                        "1718191A 1B1C1D1E 1F202122 23242526" +
                        "2728292A 2B2C2D2E 2F303132 33343536" +
                        "3738393A 3B3C3D3E 3F404142 43444546" +
                        "4748494A 4B4C4D4E 4F505152 53545556" +
                        "5758595A 5B5C5D5E 5F606162 63646566" +
                        "6768696A 6B6C6D6E 6F707172 73747576" +
                        "7778797A 7B7C7D7E 7F808182 83848586" +
                        "8788898A 8B8C8D8E 8F909192 93949596" +
                        "9798999A 9B9C9D9E 9FA0A1A2 A3A4A5A6" +
                        "A7A8A9AA ABACADAE AFB0B1B2 B3B4B5B6" +
                        "B7B8B9BA BBBCBDBE BFC0C1C2 C3C4C5C6" +
                        "C7C8");
        
        /**********************************************************************/
        /** Testcase 2. Search TLV 02h use method getValueByte(2)             */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010033 81C80102 03040506" +
                        "0708090A 0B0C0D0E 0F101112 13141516" +
                        "1718191A 1B1C1D1E 1F202122 23242526" +
                        "2728292A 2B2C2D2E 2F303132 33343536" +
                        "3738393A 3B3C3D3E 3F404142 43444546" +
                        "4748494A 4B4C4D4E 4F505152 53545556" +
                        "5758595A 5B5C5D5E 5F606162 63646566" +
                        "6768696A 6B6C6D6E 6F707172 73747576" +
                        "7778797A 7B7C7D7E 7F808182 83848586" +
                        "8788898A 8B8C8D8E 8F909192 93949596" +
                        "9798999A 9B9C9D9E 9FA0A1A2 A3A4A5A6" +
                        "A7A8A9AA ABACADAE AFB0B1B2 B3B4B5B6" +
                        "B7B8B9BA BBBCBDBE BFC0C1C2 C3C4C5C6" +
                        "C7C8");
                    
        /**********************************************************************/
        /** Testcase 3. Search TLV 02h use method getValueByte(1)             */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010033 81C80102 03040506" +
                        "0708090A 0B0C0D0E 0F101112 13141516" +
                        "1718191A 1B1C1D1E 1F202122 23242526" +
                        "2728292A 2B2C2D2E 2F303132 33343536" +
                        "3738393A 3B3C3D3E 3F404142 43444546" +
                        "4748494A 4B4C4D4E 4F505152 53545556" +
                        "5758595A 5B5C5D5E 5F606162 63646566" +
                        "6768696A 6B6C6D6E 6F707172 73747576" +
                        "7778797A 7B7C7D7E 7F808182 83848586" +
                        "8788898A 8B8C8D8E 8F909192 93949596" +
                        "9798999A 9B9C9D9E 9FA0A1A2 A3A4A5A6" +
                        "A7A8A9AA ABACADAE AFB0B1B2 B3B4B5B6" +
                        "B7B8B9BA BBBCBDBE BFC0C1C2 C3C4C5C6" +
                        "C7C8");
                        
        /**********************************************************************/
        /** Testcase 4. Search TLV 02h (Device Identities TLV)                */
        /**  use method getValueByte(0)                                       */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010033 81C80102 03040506" +
                        "0708090A 0B0C0D0E 0F101112 13141516" +
                        "1718191A 1B1C1D1E 1F202122 23242526" +
                        "2728292A 2B2C2D2E 2F303132 33343536" +
                        "3738393A 3B3C3D3E 3F404142 43444546" +
                        "4748494A 4B4C4D4E 4F505152 53545556" +
                        "5758595A 5B5C5D5E 5F606162 63646566" +
                        "6768696A 6B6C6D6E 6F707172 73747576" +
                        "7778797A 7B7C7D7E 7F808182 83848586" +
                        "8788898A 8B8C8D8E 8F909192 93949596" +
                        "9798999A 9B9C9D9E 9FA0A1A2 A3A4A5A6" +
                        "A7A8A9AA ABACADAE AFB0B1B2 B3B4B5B6" +
                        "B7B8B9BA BBBCBDBE BFC0C1C2 C3C4C5C6" +
                        "C7C8");
                        
        /**********************************************************************/
        /** Testcase 5. Search TLV 33h  use method getValueByte(7E)           */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010033 81C80102 03040506" +
                        "0708090A 0B0C0D0E 0F101112 13141516" +
                        "1718191A 1B1C1D1E 1F202122 23242526" +
                        "2728292A 2B2C2D2E 2F303132 33343536" +
                        "3738393A 3B3C3D3E 3F404142 43444546" +
                        "4748494A 4B4C4D4E 4F505152 53545556" +
                        "5758595A 5B5C5D5E 5F606162 63646566" +
                        "6768696A 6B6C6D6E 6F707172 73747576" +
                        "7778797A 7B7C7D7E 7F808182 83848586" +
                        "8788898A 8B8C8D8E 8F909192 93949596" +
                        "9798999A 9B9C9D9E 9FA0A1A2 A3A4A5A6" +
                        "A7A8A9AA ABACADAE AFB0B1B2 B3B4B5B6" +
                        "B7B8B9BA BBBCBDBE BFC0C1C2 C3C4C5C6" +
                        "C7C8");
                        
        /**********************************************************************/
        /** Testcase 6. Search TLV 33h  use method getValueByte(80)           */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010033 81C80102 03040506" +
                        "0708090A 0B0C0D0E 0F101112 13141516" +
                        "1718191A 1B1C1D1E 1F202122 23242526" +
                        "2728292A 2B2C2D2E 2F303132 33343536" +
                        "3738393A 3B3C3D3E 3F404142 43444546" +
                        "4748494A 4B4C4D4E 4F505152 53545556" +
                        "5758595A 5B5C5D5E 5F606162 63646566" +
                        "6768696A 6B6C6D6E 6F707172 73747576" +
                        "7778797A 7B7C7D7E 7F808182 83848586" +
                        "8788898A 8B8C8D8E 8F909192 93949596" +
                        "9798999A 9B9C9D9E 9FA0A1A2 A3A4A5A6" +
                        "A7A8A9AA ABACADAE AFB0B1B2 B3B4B5B6" +
                        "B7B8B9BA BBBCBDBE BFC0C1C2 C3C4C5C6" +
                        "C7C8");
                        
        /**********************************************************************/
        /** Testcase 7.  Search TLV 33h  use method getValueByte(7F)          */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010033 81C80102 03040506" +
                        "0708090A 0B0C0D0E 0F101112 13141516" +
                        "1718191A 1B1C1D1E 1F202122 23242526" +
                        "2728292A 2B2C2D2E 2F303132 33343536" +
                        "3738393A 3B3C3D3E 3F404142 43444546" +
                        "4748494A 4B4C4D4E 4F505152 53545556" +
                        "5758595A 5B5C5D5E 5F606162 63646566" +
                        "6768696A 6B6C6D6E 6F707172 73747576" +
                        "7778797A 7B7C7D7E 7F808182 83848586" +
                        "8788898A 8B8C8D8E 8F909192 93949596" +
                        "9798999A 9B9C9D9E 9FA0A1A2 A3A4A5A6" +
                        "A7A8A9AA ABACADAE AFB0B1B2 B3B4B5B6" +
                        "B7B8B9BA BBBCBDBE BFC0C1C2 C3C4C5C6" +
                        "C7C8");
                        
        /**********************************************************************/
        /** Testcase 8. Search TLV B3h  use method getValueByte(C7)           */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FDD181FA 02028381 06068111" +
                        "223344F5 8B214002 81557FF6 00112912" +
                        "00000413 02700000 0E0D0800 00002001" +
                        "01000000 00010033 81C80102 03040506" +
                        "0708090A 0B0C0D0E 0F101112 13141516" +
                        "1718191A 1B1C1D1E 1F202122 23242526" +
                        "2728292A 2B2C2D2E 2F303132 33343536" +
                        "3738393A 3B3C3D3E 3F404142 43444546" +
                        "4748494A 4B4C4D4E 4F505152 53545556" +
                        "5758595A 5B5C5D5E 5F606162 63646566" +
                        "6768696A 6B6C6D6E 6F707172 73747576" +
                        "7778797A 7B7C7D7E 7F808182 83848586" +
                        "8788898A 8B8C8D8E 8F909192 93949596" +
                        "9798999A 9B9C9D9E 9FA0A1A2 A3A4A5A6" +
                        "A7A8A9AA ABACADAE AFB0B1B2 B3B4B5B6" +
                        "B7B8B9BA BBBCBDBE BFC0C1C2 C3C4C5C6" +
                        "C7C8");
                        
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                    "08CCCCCC CCCCCCCC CC"));
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
      
        return getOverallResult();
    }
}   
