//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_cbs_mmra;

//-----------------------------------------------------------------------------
//Import
//-----------------------------------------------------------------------------
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;

public class Test_Ufw_Cbs_Mmra extends UiccTestModel
{
    static final String             CAP_FILE_PATH       = "uicc/usim/test/usatframework/ufw_cbs_mmra";

    static final String             CLASS_AID_1         = "A0000000 871005FF FFFFFF89 50010001";

    static final String             APPLET_AID_1        = "A0000000 871005FF FFFFFF89 50010102";

    /** Formatted SMS_CB 1 of 3 */
    static final String             FORMATTED_SMSCB_1   = "8C58A750 1093F613 00F40D00 00000050"
                                                        + "01010000 00000000 01020304 05060708"
                                                        + "090A0B0C 0D0E0F10 11121314 15161718"
                                                        + "191A1B1C 1D1E1F20 21222324 25262728"
                                                        + "292A2B2C 2D2E2F30 31323334 35363738"
                                                        + "393A3B3C 3D3E3F40 4142";

    /** Formatted SMS_CB 2 of 3 */
    static final String             FORMATTED_SMSCB_2  = "8C58A750 1093F623 43444546 4748494A"
                                                       + "4B4C4D4E 4F505152 53545556 5758595A"
                                                       + "5B5C5D5E 5F606162 63646566 6768696A"
                                                       + "6B6C6D6E 6F707172 73747576 7778797A"
                                                       + "7B7C7D7E 7F808182 83848586 8788898A"
                                                       + "8B8C8D8E 8F909192 9394";
    /** Formatted SMS_CB 3 of 3 */
    static final String             FORMATTED_SMSCB_3  = "8C58A750 1093F633 95969798 999A9B9C"
                                                       + "9D9E9FA0 A1A2A3A4 A5A6A7A8 A9AAABAC"
                                                       + "ADAEAFB0 B1B2B3B4 B5B6B7B8 B9BABBBC"
                                                       + "BDBEBFC0 C1C2C3C4 C5C6C7C8 C9CACBCC"
                                                       + "CDCECFD0 D1D2D3D4 D5D6D7D8 D9DADBDC"
                                                       + "DDDEDFE0 E1E2E3E4 E5E6";
    /** Unformatted SMS_CB 1 of 3 */
    static final String             UNFORMATTED_SMSCB_1 = "8C58A751 1077F613 00180D00 00000050"
                                                        + "01010000 00000000 01020304 05060708"
                                                        + "090A0B0C 0D0E0F10 11121314 15161718"
                                                        + "191A1B1C 1D1E1F20 21222324 25262728"
                                                        + "292A2B2C 2D2E2F30 31323334 35363738"
                                                        + "393A3B3C 3D3E3F40 4142";

    /** Unformatted SMS_CB 2 of 3 */
    static final String             UNFORMATTED_SMSCB_2 = "8C58A751 1077F623 43444546 4748494A"
                                                        + "4B4C4D4E 4F505152 53545556 5758595A"
                                                        + "5B5C5D5E 5F606162 63646566 6768696A"
                                                        + "6B6C6D6E 6F707172 73747576 7778797A"
                                                        + "7B7C7D7E 7F808182 83848586 8788898A"
                                                        + "8B8C8D8E 8F909192 9394";

    /** Unformatted SMS_CB 3 of 3 */
    static final String            UNFORMATTED_SMSCB_3 = "8C58A751 1077F633 95969798 999A9B9C"
                                                       + "9D9E9FA0 A1A2A3A4 A5A6A7A8 A9AAABAC"
                                                       + "ADAEAFB0 B1B2B3B4 B5B6B7B8 B9BABBBC"
                                                       + "BDBEBFC0 C1C2C3C4 C5C6C7C8 C9CACBCC"
                                                       + "CDCECFD0 D1D2D3D4 D5D6D7D8 D9DADBDC"
                                                       + "DDDEDFE0 E1E2E3E4 E5E6";

    private USimAPITestCardService test;

    private APDUResponse           response;

    public Test_Ufw_Cbs_Mmra() {
        test = USimAPITestCardService.getTheUSimTestCardService();

    }

    public boolean run()
    {
        initialiseResults();

        // test script
        test.reset();
        test.terminalProfileSession("03010000 0102");

        // Install Applet1
        test.loadPackage(CAP_FILE_PATH);
        // Install Applet1
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1,
                            "8008" + // TLV UICC Toolkit application specific parameters
                            "01" +   // V Priority Level
                            "00" +   // V Max. number of timers
                            "00" +   // V Maximum text length for a menu entry
                            "00" +   // V Maximum number of menu entries
                            "00" +   // V Maximum number of channels
                            "00" +   // LV Minimum Security Level field
                            "00" +   // LV TAR Value(s)
                            "00" );  // V Maximum number of services

        // check terminal profile
        test.reset();
        test.terminalProfileSession("16000002");

        // TC 1 - send formatted SMS-CB and check content
        response = test.envelopeCellBroadcast(FORMATTED_SMSCB_1);
        response = test.envelopeCellBroadcast(FORMATTED_SMSCB_2);
        response = test.envelopeCellBroadcast(FORMATTED_SMSCB_3);
       
         //TC 2 - send unformatted SMS-CB and check content
         response = test.envelopeCellBroadcast(UNFORMATTED_SMSCB_2);
         response = test.envelopeCellBroadcast(UNFORMATTED_SMSCB_3);
         response = test.envelopeCellBroadcast(UNFORMATTED_SMSCB_1);

        // get test result
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 + "02CCCC"));

        // delete applet and package
        test.reset();
        test.terminalProfileSession("03010000 0102");
        test.deleteApplet(APPLET_AID_1);
        test.deletePackage(CAP_FILE_PATH);

        return getOverallResult();
    }
}
