//-----------------------------------------------------------------------------
//ufw_fws_inda_5.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_fws_inda;

import uicc.usim.test.util.*;
import uicc.usim.toolkit.*;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

/**
 * Test Area : uicc.usim.test.ufwk.ufw_fws_inda
 *
 * @version 0.0.1 - 6 sept. 2005
 * @author 3GPP T3 SWG API
 */
public class Ufw_Fws_Inda_5 extends TestToolkitApplet implements uicc.usim.toolkit.ToolkitConstants
{
    // Number of tests
    byte testCaseNb = (byte) 0x01;
    byte[] buffer = new byte[25];
    byte[] comparebuffer = {(byte)0x01,(byte)0x02,(byte)0x03,(byte)0x04,(byte)0x05,(byte)0x06,(byte)0x07,(byte)0x08,(byte)0x09,(byte)0x0A,(byte)0x0B,(byte)0x0C,(byte)0x0D,(byte)0x0E,(byte)0x0F,(byte)0x10,
            (byte)0x11,(byte)0x12,(byte)0x13,(byte)0x14,(byte)0x15,(byte)0x16,(byte)0x17,(byte)0x18,(byte)0x19,(byte)0x1A,(byte)0x1B,(byte)0x1C,(byte)0x1D,(byte)0x1E,(byte)0x1F,(byte)0x20,
            (byte)0x21,(byte)0x22,(byte)0x23,(byte)0x24,(byte)0x25,(byte)0x26,(byte)0x27,(byte)0x28,(byte)0x29,(byte)0x2A,(byte)0x2B,(byte)0x2C,(byte)0x2D,(byte)0x2E,(byte)0x2F,(byte)0x30,
            (byte)0x31,(byte)0x32,(byte)0x33,(byte)0x34,(byte)0x35,(byte)0x36,(byte)0x37,(byte)0x38,(byte)0x39,(byte)0x3A,(byte)0x3B,(byte)0x3C,(byte)0x3D,(byte)0x3E,(byte)0x3F,(byte)0x40,
            (byte)0x41,(byte)0x42,(byte)0x43,(byte)0x44,(byte)0x45,(byte)0x46,(byte)0x47,(byte)0x48,(byte)0x49,(byte)0x4A,(byte)0x4B,(byte)0x4C,(byte)0x4D,(byte)0x4E,(byte)0x4F,(byte)0x50,
            (byte)0x51,(byte)0x52,(byte)0x53,(byte)0x54,(byte)0x55,(byte)0x56,(byte)0x57,(byte)0x58,(byte)0x59,(byte)0x5A,(byte)0x5B,(byte)0x5C,(byte)0x5D,(byte)0x5E,(byte)0x5F,(byte)0x60,
            (byte)0x61,(byte)0x62,(byte)0x63,(byte)0x64,(byte)0x65,(byte)0x66,(byte)0x67,(byte)0x68,(byte)0x69,(byte)0x6A,(byte)0x6B,(byte)0x6C,(byte)0x6D,(byte)0x6E,(byte)0x6F,(byte)0x70,
            (byte)0x71,(byte)0x72,(byte)0x73,(byte)0x74,(byte)0x75,(byte)0x76,(byte)0x77,(byte)0x78,(byte)0x79,(byte)0x7A,(byte)0x7B,(byte)0x7C,(byte)0x7D,(byte)0x7E,(byte)0x7F,(byte)0x80,
            (byte)0x81,(byte)0x82,(byte)0x83,(byte)0x84,(byte)0x85,(byte)0x86,(byte)0x87,(byte)0x88,(byte)0x89,(byte)0x8A,(byte)0x8B,(byte)0x8C,(byte)0x8D,(byte)0x8E,(byte)0x8F,(byte)0x90,
            (byte)0x91,(byte)0x92,(byte)0x93,(byte)0x94,(byte)0x95,(byte)0x96 };

    /**
    * Constructor of the applet
    */
    public Ufw_Fws_Inda_5 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Ufw_Fws_Inda_5  thisApplet = new Ufw_Fws_Inda_5();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init(); 
        
        //register to EVENT_FORMATTED_SMS_PP_ENV
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        
         // Register to EVENT_FORMATTED_SMS_PP_UPD
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);

    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of each test
        boolean bRes = false;

        // Get the system instance of the EnvelopeHandler class
        USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();

        
        short length = 0;
        short offset = 0;
        byte data = 0;

        switch ( testCaseNb )
            {
                case (byte) 1 :
                // --------------------------------------------
                // Test Case 7.1: data ciphered; integrity checked via cryptographic checksum
                //
                // In this test case it is checked that the checksum is verified and the data are deciphered
                // before being passed to the applet
                try {
                    bRes = false;
                    offset = envHdlr.getSecuredDataOffset();
                    length = envHdlr.getSecuredDataLength();
                    envHdlr.copyValue(offset, (byte[])buffer, (short)0x00, length);
                    data = buffer [0];
                    if ((data == (byte)1) && (length == (short)1)) {
                        bRes = true;
                    }
                }
                catch (Exception e)    {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb=(byte) 0x02;
                break;
                
                
                case (byte) 2 :
                // --------------------------------------------
                // Test Case 7.2: data ciphered; integrity checked via cryptographic checksum
                //
                // In this test case it is checked that the checksum is verified and the data are deciphered
                // before being passed to the applet
                try {
                    bRes = false;
                    offset = envHdlr.getSecuredDataOffset();
                    length = envHdlr.getSecuredDataLength();
                    if ((envHdlr.compareValue(offset,comparebuffer,(short)0,length) == (byte)0) && (length == (short)150)) {
                        bRes = true;
                    }
                }
                catch (Exception e)    {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb=(byte) 0x03;
                break;
                

                case (byte) 3 :
                // --------------------------------------------
                // Test Case 8.1: data ciphered; integrity checked via cryptographic checksum
                //
                // In this test case it is checked that applet FWK_FWS_INDA_1 is triggered
                // instead of applet FWK_FWS_INDA_2
                try {
                    bRes = false;
                    offset = envHdlr.getSecuredDataOffset();
                    length = envHdlr.getSecuredDataLength();
                    envHdlr.copyValue(offset, (byte[])buffer, (short)0x00, length);
                    data = buffer [0];
                    if ((data == (byte)3) && (length == (byte)1)) {
                        bRes = true;
                    }
                }
                catch (Exception e)    {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb=(byte) 0x04;
                break;
                
                case (byte) 4 :
                // --------------------------------------------
                // Test Case 8.2: data ciphered; integrity checked via cryptographic checksum
                //
                // In this test case it is checked that applet FWK_FWS_INDA_1 is triggered
                // instead of applet FWK_FWS_INDA_2
                try {
                    bRes = false;
                    offset = envHdlr.getSecuredDataOffset();
                    length = envHdlr.getSecuredDataLength();
                    if ((envHdlr.compareValue(offset,comparebuffer,(short)0,length) == (byte)0) && (length == (short)150)) {
                        bRes = true;
                    }
                }
                catch (Exception e)    {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, true);
                testCaseNb=(byte) 0x05;
                break;
                

                default :
                // --------------------------------------------
                // Test Case 9: data ciphered; integrity checked via cryptographic checksum
                //
                // In this test case it is checked that applet FWK_FWS_INDA_5 is NOT TRIGGERED
                // Therefore, the result is false if this piece of code is executed
                reportTestOutcome((byte)0x05, false);
                break;

            }

    }
}
