//-----------------------------------------------------------------------------
//Test_Ufw_fws_ouda.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_fws_ouda;

import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

/**
 * Test Area : uicc.usim.test.ufwk.ufw_fws_ouda
 *
 * @version 0.0.1 - 9 sept. 2005
 * @author 3GPP T3 SWG API
 */
public class Test_Ufw_Fws_Ouda extends UiccTestModel {


    static final String             CAP_FILE_PATH   = "uicc/usim/test/usatframework/ufw_fws_ouda";

    private final String            CLASS_AID_1     = "A0000000 871005FF FFFFFF89 50010001";
    private final String            APPLET_AID_1    = "A0000000 871005FF FFFFFF89 50010102";
    
    /** */
    private USimAPITestCardService test;
    /** contains the response of the processed apdu*/
    private APDUResponse response;

    private static String           ADF_1_AID           = "A0000000090005FFFFFFFF89E0000002";;
    /** */
    public Test_Ufw_Fws_Ouda() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    /**
     * @todo terminal profile
     */
    public boolean run() {
            
            initialiseResults();
         
            // test script
            test.reset();
            test.terminalProfileSession("03010000 0102");
            // Install package
            test.loadPackage(CAP_FILE_PATH);
            // Install Applet1
            test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                                "8008" + // TLV UICC Toolkit application specific parameters
                                "01" +   // V Priority Level
                                "00" +   // V Max. number of timers
                                "00" +   // V Maximum text length for a menu entry
                                "00" +   // V Maximum number of menu entries                              
                                "00" +   // V Maximum number of channels 
                                "00" +   // LV Minimum Security Level field
                                "00" +   // LV TAR Value(s) 
                                "00" );  // V Maximum number of services
            
          
            //Send terminal profile
            test.reset();
            test.terminalProfileSession("03010000 0102");
            
            // Test Case 1 : Single authenticated and ciphered Envelope(SMS_PP).
            response = test.envelopeSmsPp("8B364008 81556677 887FF600 11291200"
                                        + "00042502 70000020 150E0111 11500101"
                                        + "39750E40 FB451508 CDFD528A 873B8547"
                                        + "30C884F6 B4D8A69A");
            // No data was posted by the applet
            addResult(response.checkData("02710000 0B0A5001 01000000 00010000"));
            addResult(response.checkSw("9115"));
            
            // Fetch the display text proactive command
            response = test.fetch("15");
            addResult(response.checkData("D0138103 01218082 0281028D 08044150"
                                       + "504C4554 31"));
            test.terminalResponse("81030121 80820282 81830100");

            // Test case 2 : Single SMSPP is send to the applet 
            response = test.envelopeSmsPp("8B364008 81556677 887FF600 11291200"
                                        + "00042502 70000020 150E0111 11500101"
                                        + "39750E40 FB451508 CDFD528A 873B8547"
                                        + "30C884F6 B4D8A69A");

            // Check data posted by the applet
            addResult(response.checkData("02710000 120A5001 01000000 00010000"
                                       + "4150504C 455431"));
            addResult(response.checkSw("9000"));
            
            // Test case 3 : Single SMSPP is send to the applet 
            response = test.envelopeSmsPp("8B364008 81556677 887FF600 11291200"
                                        + "00042502 70000020 150E0111 11500101"
                                        + "88C8F6BD 2725BD50 002A44C0 E9E25577"
                                        + "1713EBE8 F098E965");
            
            // Check data posted by the applet
            addResult(response.checkData("02710000 120A5001 01000000 00010000"
                                       + "4150504C 455431"));
            
            addResult(response.checkSw("9112"));
            // Fetch the display text proactive command
            response = test.fetch("12");
            addResult(response.checkData("D0108103 01218082 0281028D 05045445"
                                       + "5354"));
            
            test.terminalResponse("81030121 80820282 81830100");
            
            // Test case 4 : Ciphered proof of receipt required 
            response = test.envelopeSmsPp("8B364008 81556677 887FF600"
                                        + "11291200 00042502 70000020"
                                        + "150E1111 11500101 BAAE6A9D"
                                        + "B01BE72C 69468D00 9B3B3FAC"
                                        + "922F3378 AA46CF21");
            
            // Check data posted by the applet
            addResult(response.checkData("02710000 140A5001 013DFE89 4702886C"
                                       + "DFA30E6C E2623341 73"));
            
            addResult(response.checkSw("9112"));
            // Fetch the display text proactive command
            response = test.fetch("12");
            addResult(response.checkData("D0108103 01218082 0281028D 05045445"
                                       + "5354"));
            
            test.terminalResponse("81030121 80820282 81830100");
            
            //get test result
            response = test.selectApplication(APPLET_AID_1);
            addResult(response.checkData("10"+APPLET_AID_1+
                                         "04CCCCCC CC"));
            
            // delete applet and package
            test.reset();
            test.terminalProfile("0301");
            test.deleteApplet(APPLET_AID_1);
            test.deletePackage(CAP_FILE_PATH);

            return getOverallResult();
    }
}
